<template>
  <div class="edit-container">
    <save-context
      ref="saveContext"
      :value="course"
      name="course"
      :save-key="`course:${course.id}`"
      #default="{ course, original, edited }"
    >
      <div class="edit-controls">
        <el-collapse v-model="trays">
          <el-collapse-item name="course" title="Course Details">
            <el-input placeholder="Course Name" v-model="course.name" />
            <el-input
              type="textarea"
              placeholder="Course Description"
              v-model="course.description"
            />
          </el-collapse-item>
          <el-collapse-item class="wide" name="checkpoints" title="Checkpoints">
            <div v-if="course.checkpoints.nodes.length == 0">
              <p>
                Create checkpoints by double-clicking on the map. Once you've
                created a few checkpoints, you can select the start & finish
                checkpoints here.
              </p>
            </div>
            <div v-else>
              <div
                v-for="cp in course.checkpoints.nodes"
                :key="cp.id"
                class="cp-table-row"
              >
                <el-input class="name" v-model="cp.name" placeholder="Name" />
                <el-input
                  class="description"
                  v-model="cp.description"
                  placeholder="Description"
                />
                {{ cp | easting }}E {{ cp | northing }}N
              </div>
              <p>
                You may specify a start and end checkpoint (they may be the same
                one!).
              </p>
              <div>
                Start:
                <el-select v-model="course.startCheckpointId">
                  <el-option
                    v-for="cp in course.checkpoints.nodes"
                    :key="cp.id"
                    :label="cp.name"
                    :value="cp.id"
                  />
                </el-select>
              </div>
              <div>
                End:
                <el-select v-model="course.endCheckpointId">
                  <el-option
                    v-for="cp in course.checkpoints.nodes"
                    :key="cp.id"
                    :label="cp.name"
                    :value="cp.id"
                  />
                </el-select>
              </div>
            </div>
          </el-collapse-item>
          <el-collapse-item name="layer-config" title="Map Layers">
            <LayerControls />
          </el-collapse-item>
          <el-collapse-item name="print-config" title="Print Configuration">
            <PrintConfigControls
              v-if="editingPrintConfig"
              :layer="$refs.printConfig"
              v-model="course.printConfig"
            />
            <div>
              <h4>Custom maps</h4>
              <ul v-if="course && course.printFiles">
                <li v-for="file in course.printFiles.nodes" :key="file.id">
                  <a :href="file.url">{{ file.name }}</a>
                  <careful-button @click="deletePrintFile(file)"
                    >Delete</careful-button
                  >
                </li>
              </ul>
              Upload Custom Maps:
              <FileUpload @input="uploadedMap" endpoint="/upload" />
            </div>
          </el-collapse-item>

          <el-collapse-item name="settings" title="Settings">
            <div>
              <el-checkbox
                :disabled="!course.endCheckpointId || !course.startCheckpointId"
                v-model="course.public"
                >Public</el-checkbox
              >
            </div>
            <div v-if="!course.endCheckpointId || !course.startCheckpointId">
              Note: You may not publish your course until a start and end
              checkpoint have been specified. They may be the same checkpoint!
            </div>
            <careful-button @click="deleteCourse(course)"
              >Delete Course</careful-button
            >
          </el-collapse-item>
          <el-collapse-item name="export" title="Export">
            <div>
              <a target="_blank" :href="`/courses/${course.id}/export.gpx`"
                >Export GPX</a
              >
            </div>
            <div>
              <a target="_blank" :href="`/courses/${course.id}/export.json`"
                >Export GeoJSON (best for CalTopo)</a
              >
            </div>
          </el-collapse-item>
        </el-collapse>
        <div class="buttons-panel" v-if="edited">
          <stateful-button @click="save(course, original)"
            >Save</stateful-button
          >
          <careful-button @click="reset(course, original)"
            >Reset</careful-button
          >
        </div>
        <div class="buttons-panel" v-else>
          <nuxt-link class="button" :to="`/courses/${course.id}/`"
            >Done</nuxt-link
          >
          <nuxt-link class="button" :to="`/run/course?id=${course.id}`"
            >Run</nuxt-link
          >
          <nuxt-link
            class="button"
            :to="`/print/${course.id}`"
            v-if="course.printConfig"
            >Print</nuxt-link
          >
        </div>
      </div>

      <portal to="map">
        <Checkpoint
          :ref="`cp-${cp.id}`"
          v-for="cp in course.checkpoints.nodes"
          :key="`edit-${cp.id}-mrk`"
          :value="cp"
          :draggable="true"
        >
          <template>
            <MglPopup
              :key="`edit-${cp.id}`"
              @open="open($event.popup)"
              @close="close($event.popup)"
              :offset="[0, -10]"
              height="130"
            >
              <div>
                <el-input
                  :ref="`nameField-${cp.id}`"
                  class="name"
                  v-model="cp.name"
                  placeholder="Name"
                />
                <el-input
                  class="description"
                  type="textarea"
                  v-model="cp.description"
                  placeholder="Description"
                />
                <el-select v-model="cp.radius">
                  <el-option :value="10" label="10m radius" />
                  <el-option :value="25" label="25m radius" />
                  <el-option :value="50" label="50m radius" />
                  <el-option :value="100" label="100m radius" />
                </el-select>
                <careful-button size="mini" @click="deleteCp(course, cp)"
                  >Delete</careful-button
                >
              </div>
            </MglPopup>
          </template>
        </Checkpoint>

        <PrintConfigLayer
          v-if="editingPrintConfig"
          ref="printConfig"
          v-model="course.printConfig"
        />

        <MglConfig
          :items="course.checkpoints.nodes"
          :watching="false"
          @dblclick="createCheckpoint(course, $event)"
        />
      </portal>
    </save-context>
  </div>
</template>
<style lang="scss">
@import "~assets/mixins.scss";

.edit-container {
  position: relative;

  max-height: 85vh;
  overflow-y: auto;
}

.edit-controls {
  padding-bottom: $grid * 3;

  color: white;

  .el-collapse-item__wrap,
  .el-collapse-item__header {
    background-color: transparent;
  }

  .cp-table-row {
    display: flex;
    flex-direction: row;

    .name {
      width: $grid * 5;
    }
    .description {
      width: $grid * 10;
    }
  }

  .buttons-panel {
    position: absolute;
    bottom: 0;
    left: 0;
    width: $grid * 16;
    padding-bottom: $grid * 0.5;

    display: flex;
    flex-direction: row;

    & > * {
      flex-grow: 1;
      flex-shrink: 1;
      flex-basis: 0;
      margin: 0 $grid;
    }
  }
}
</style>
<script>
import { uuid, boundsFor, inherit, hashWithout, difference } from "~/lib/utils";
import SaveContext from "~/components/SaveContext";
import CarefulButton from "~/components/CarefulButton";
import Checkpoint from "~/components/mapping/Checkpoint";
import MglConfig from "~/components/mapping/MglConfig";
import LayerControls from "~/components/mapping/LayerControls";
import FileUpload from "~/components/ui/forms/FileUpload";

import * as UTM from "utm";

import { query } from "~/plugins/data-management";
function lastRadius(cps) {
  if (!cps) return null;
  const cp = cps[cps.length - 1];
  if (!cp) return null;
  return cp.radius;
}

const FIELDS = `id name description public printConfig
startCheckpointId endCheckpointId
  checkpoints(orderBy: [NAME_ASC]) { nodes { id name lat lng description  radius}  }
printFiles { nodes {
id name url
} }
`;

const GET = `query($id: UUID!) {
  course : course(id: $id) { ${FIELDS} }
}`;

const DELETE = `mutation ($id:UUID!) {
  deleteCourse(input:{id:$id}) { clientMutationId }
  }`;

const ADD_MAP = `mutation($uuid:UUID!,$courseId:UUID!,$name:String,$url:String!) {
  createPrintFile(input: {
    printFile: {
      id: $uuid
      url: $url
      name: $name
      courseId: $courseId,
    }
  }) {
    printFile { id url name }
  }
}`;

const DELETE_MAP = `mutation($id: UUID!) {
  deletePrintFile(input: {id: $id}) {
    printFile {
      id
    }
  }
}`;

export default {
  components: {
    SaveContext,
    MglConfig,
    Checkpoint,
    CarefulButton,
    FileUpload,
    LayerControls,
    PrintConfigLayer: () =>
      import("~/components/mapping/PrintConfigLayer").then(
        (d) => d.default || d
      ),
    PrintConfigControls: () =>
      import("~/components/mapping/PrintConfigControls").then(
        (d) => d.default || d
      ),
  },
  data() {
    return {
      openPopups: [],
      trays: ["course"],
    };
  },
  asyncData: async (ctx) => {
    const res = await query(GET, ({ route }) => ({ id: route.params.id }))(ctx);
    if (res.course == null) return ctx.error("404 - Course Not Found");
    return res;
  },

  mounted() {},
  beforeDestroy() {},

  computed: {
    editingPrintConfig() {
      return this.trays.includes("print-config");
    },
  },
  filters: {
    easting(value) {
      return (
        value &&
        UTM.fromLatLon(Number(value.lat), Number(value.lng)).easting.toFixed(0)
      );
    },
    northing(value) {
      return (
        value &&
        UTM.fromLatLon(Number(value.lat), Number(value.lng)).northing.toFixed(0)
      );
    },
  },

  methods: {
    open(popup) {
      this.openPopups.push(popup);
    },
    close(popup) {
      const i = this.openPopups.indexOf(popup);
      this.openPopups.splice(i, 1);
      this._lastPopupClosedTime = new Date();
    },
    async deleteCourse(course) {
      const { error, result } = await this.$gql(DELETE, { id: course.id });

      if (result) {
        this.$router.push("/");
      } else {
        alert("An error occurred.");
      }
    },
    printPreview(event) {
      window.open(`/print/${this.course.id}`, "_blank");
    },
    async uploadedMap(file) {
      const { result, error } = await this.$gql(ADD_MAP, {
        ...file.result,
        courseId: this.course.id,
      });

      if (error) this.$report(error);
      else {
        this.course.printFiles.nodes.push(result.createPrintFile.printFile);
      }
    },
    async deletePrintFile(file) {
      const { result, error } = await this.$gql(DELETE_MAP, { id: file.id });

      if (error) throw error;
      else {
        let index = this.course.printFiles.nodes.findIndex(
          (e) => e.id == file.id
        );
        this.course.printFiles.nodes.splice(index, 1);
      }
    },
    dragCp(cp, event) {
      const lngLat = event.marker.getLngLat();
      cp.lat = lngLat.lat;
      cp.lng = lngLat.lng;
    },
    createCheckpoint(course, event) {
      const radius = lastRadius(course.checkpoints.nodes) || 50;

      if (this.openPopups.length > 0) return;
      if (
        this._lastPopupClosedTime &&
        new Date() - this._lastPopupClosedTime < 750
      )
        return;

      const latlng = event.lngLat;

      function padLeft(string, padding, length) {
        return `${padding.repeat(length - string.length)}${string}`;
      }

      function exists(name) {
        return course.checkpoints.nodes.find((c) => c.name == name);
      }

      function firstUnique() {
        let name;

        for (let i = 1; i < 100; i++) {
          name = `CP${padLeft(`${i}`, "0", 2)}`;
          // name = `CP${i}`;

          if (!exists(name)) return name;
        }
        return "";
      }

      var id = uuid();
      var h = {
        name: firstUnique(),
        lat: latlng.lat,
        lng: latlng.lng,
        courseId: this.course.id,
        id: id,
        radius: radius,
      };
      console.log("H: ", h);
      var i = course.checkpoints.nodes.length;
      course.checkpoints.nodes.push(h);

      setTimeout(() => {
        var checkpoint = this.$refs[`cp-${id}`][0];

        checkpoint.togglePopup();
        var field = this.$refs[`nameField-${id}`][0];
        field.focus();
      }, 150);
    },
    deleteCp(course, cp) {
      const index = course.checkpoints.nodes.findIndex((c) => c.id == cp.id);
      course.checkpoints.nodes.splice(index, 1);
    },
    async reset(course, original) {
      this.$set(this, "course", JSON.parse(JSON.stringify(original)));
    },
    async save(course, original) {
      const courseDiff = hashWithout(this.course, [
        "checkpoints",
        "printFiles",
      ]);
      const deleteCPs = difference(
        original.checkpoints.nodes,
        course.checkpoints.nodes,
        (a, b) => a.id == b.id
      );
      const upsertCPs = course.checkpoints.nodes;

      const mutations = [];
      const variableTypes = [];
      const variables = {};

      for (var i in upsertCPs) {
        variableTypes.push(`$cp${i}:CheckpointInput!`);
        variables[`cp${i}`] = { ...upsertCPs[i], courseId: course.id };
        mutations.push(
          `cp${i}:upsertCheckpoint(input:{checkpoint:$cp${i}}) { clientMutationId }`
        );
      }

      variableTypes.push("$course:CourseInput!");
      variables["course"] = courseDiff;
      mutations.push(
        `course:upsertCourse(input:{course:$course}) {  
            course { ${FIELDS} } 
            }`
      );

      for (var i in deleteCPs) {
        variableTypes.push(`$dcp${i}:UUID!`);
        variables[`dcp${i}`] = deleteCPs[i].id;
        mutations.push(
          `dcp${i}:deleteCheckpoint(input:{id:$dcp${i}}) { clientMutationId }`
        );
      }

      const { result, error } = await this.$gql(
        `mutation(${variableTypes.join(" ")}) {
        ${mutations.join("\n")}
        }`,
        variables
      );

      if (error) return this.$nuxt.error(error);

      this.course = result.course.course;
    },
  },
};
</script>
